VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "Comdlg32.ocx"
Begin VB.Form frmMain 
   Caption         =   "ARC Extractor for Experience 112"
   ClientHeight    =   4740
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   6900
   LinkTopic       =   "frmMain"
   ScaleHeight     =   4740
   ScaleWidth      =   6900
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdFind 
      Appearance      =   0  'Flat
      Caption         =   "..."
      DisabledPicture =   "frmMain.frx":0000
      Height          =   315
      Left            =   6555
      Style           =   1  'Graphical
      TabIndex        =   7
      Tag             =   "cmd2"
      Top             =   90
      Width           =   300
   End
   Begin VB.OptionButton optSingleDouble 
      Caption         =   "2 - bytes data"
      Height          =   225
      Index           =   1
      Left            =   2190
      TabIndex        =   6
      Top             =   510
      Width           =   1515
   End
   Begin VB.OptionButton optSingleDouble 
      Caption         =   "1 - byte data"
      Height          =   225
      Index           =   0
      Left            =   645
      TabIndex        =   4
      Top             =   525
      Value           =   -1  'True
      Width           =   1515
   End
   Begin VB.TextBox txtOperationLog 
      Height          =   3000
      Left            =   90
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   2
      Top             =   840
      Width           =   6735
   End
   Begin VB.CommandButton cmdExtract 
      Caption         =   "Extract"
      Height          =   615
      Left            =   4200
      TabIndex        =   1
      Top             =   4005
      Width           =   2550
   End
   Begin VB.TextBox txtFileName 
      Height          =   345
      Left            =   660
      TabIndex        =   0
      Top             =   75
      Width           =   5895
   End
   Begin MSComDlg.CommonDialog cd 
      Left            =   135
      Top             =   4050
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Label labType 
      Caption         =   "Type"
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   495
      Width           =   510
   End
   Begin VB.Label labFile 
      Caption         =   "File"
      Height          =   255
      Left            =   135
      TabIndex        =   3
      Top             =   135
      Width           =   585
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim sLogData As String
Dim sLogProgress As String
Dim sLogHeader As String
Dim sExtractPath As String

Dim lDataFactor As Long
Dim iFile  As Integer
Dim FileLength As Long
Dim DirOffset As Long
Dim FilesCount As Long
Dim DirXor() As Byte
Dim DirXorLong As Long
Dim FileOffset As Long
Dim FileXor() As Byte
Dim FileSize As Long
Dim FileName As String
Dim FilePath As String

Private Sub cmdExtract_Click()
Dim bytData As Byte
Dim bytArray() As Byte
Dim sHex As String
Dim i As Long


On Error GoTo FileOpenError:

    If optSingleDouble(1) Then
        lDataFactor = 2
    Else
        lDataFactor = 1
    End If
    
    iFile = FreeFile
    Open txtFileName For Binary As iFile
    FileLength = LOF(iFile)
        
On Error GoTo FileHeaderError:

    Call GetMagic(iFile)
    Call GetVersion(iFile)
    Call GetFilesCount(iFile)
    Call GetDirOffset(iFile)
    Call GetDirXOR(iFile)
    
On Error GoTo FileExtractError:

    For i = 1 To FilesCount
            
        sLogHeader = "Extracting ARC file ... " & Format(100 * i / FilesCount, "###0") & "%"
        Call PrintLog
        
        Call GetFileName(iFile, i)
        Call GetFilePath(iFile, i)
        Call GetFileOffset(iFile, i)
        Call GetFileSize(iFile, i)
        Call GetFileXor(iFile, i)
        
        Call Unpack(iFile, i)
                    
    Next i
    
    sLogHeader = "Extracting ARC file ... 100%" & vbCrLf
    Call PrintLog
        
    Call MsgBox("Extracting finished sucessfully", vbOKOnly + vbInformation, "ARC Extractor")
    
On Error GoTo FileCloseError:
    
    Close iFile
    Exit Sub
    
FileOpenError:
    Call MsgBox("File opening error", vbOKOnly + vbCritical, "ARC Extractor")
    Exit Sub
    
FileHeaderError:
    Call MsgBox("File header reading error", vbOKOnly + vbCritical, "ARC Extractor")
    Exit Sub

FileExtractError:
    Call MsgBox("File extracting error", vbOKOnly + vbCritical, "ARC Extractor")
    Exit Sub

FileCloseError:
    Call MsgBox("File closing error", vbOKOnly + vbCritical, "ARC Extractor")
    Exit Sub

End Sub


Private Sub GetMagic(iFile As Integer)
Dim bytArray() As Byte

    ReDim bytArray(1 To 4)
    Get iFile, 1, bytArray
    
End Sub

Private Sub GetVersion(iFile As Integer)
Dim lVersion As Long
Dim bytArray() As Byte

    ReDim bytArray(1 To 4)

    Get iFile, 5, bytArray
    Get iFile, 5, lVersion
    
End Sub


Private Sub GetFilesCount(iFile As Integer)
Dim lFilesCount As Long
Dim bytArray() As Byte

    ReDim bytArray(1 To 4)

    Get iFile, 9, bytArray
    Get iFile, 9, lFilesCount
    
    FilesCount = lFilesCount
    
End Sub

Private Sub GetDirOffset(iFile As Integer)
Dim lDirOffset As Long
Dim bytArray() As Byte

    ReDim bytArray(1 To 4)

    Get iFile, 13, bytArray
    Get iFile, 13, lDirOffset
    
    DirOffset = lDirOffset
    
End Sub


Private Sub GetDirXOR(iFile As Integer)
Dim lDirXor As Long

    ReDim DirXor(1 To 4)

    Get iFile, FileLength - 3, DirXor
    Get iFile, FileLength - 3, lDirXor
    
    DirXorLong = lDirXor
    
End Sub

Private Function GetHex(bytArray() As Byte) As String
Dim i As Long
Dim sHex As String

    For i = LBound(bytArray) To UBound(bytArray)
        sHex = sHex + Right("00" & Hex(bytArray(i)), 2) & " "
    Next i
    
    GetHex = Left(sHex, Len(sHex) - 1)
    
End Function

Private Sub GetFileName(iFile As Integer, iFilenumber As Long)
Dim sFileName As String
Dim bytArrayOrg() As Byte
Dim bytArray() As Byte
Dim i As Long
Dim bSkip As Boolean

    sFileName = ""
    ReDim bytArray(1 To 128 * lDataFactor)
    ReDim bytArrayOrg(1 To 128 * lDataFactor)

    Get iFile, DirOffset + (CLng(iFilenumber) - 1) * ((128 + 256) * lDataFactor + 12) + 1, bytArrayOrg
    Get iFile, DirOffset + (CLng(iFilenumber) - 1) * ((128 + 256) * lDataFactor + 12) + 1, bytArray
    
    
    For i = LBound(bytArray) To UBound(bytArray)
        
        bSkip = False
        
        If lDataFactor = 2 And i Mod 2 = 0 Then bSkip = True
            
        If Not bSkip Then
            
            bytArray(i) = bytArray(i) Xor DirXor(((i - 1) Mod 4) + 1)
            
            If bytArray(i) <> 0 Then
                sFileName = sFileName & Chr(bytArray(i))
            Else
                Exit For
            End If
                    
        End If
    Next i
    
    FileName = sFileName
    
End Sub

Private Sub GetFilePath(iFile As Integer, iFilenumber As Long)
Dim sFilePath As String
Dim bytArrayOrg() As Byte
Dim bytArray() As Byte
Dim i As Long
Dim bSkip As Boolean

    sFilePath = ""
    
    ReDim bytArray(1 To 256 * lDataFactor)
    ReDim bytArrayOrg(1 To 256 * lDataFactor)

    Get iFile, DirOffset + (CLng(iFilenumber) - 1) * ((128 + 256) * lDataFactor + 12) + (128 * lDataFactor) + 1, bytArrayOrg
    Get iFile, DirOffset + (CLng(iFilenumber) - 1) * ((128 + 256) * lDataFactor + 12) + (128 * lDataFactor) + 1, bytArray
     
    
    For i = LBound(bytArray) To UBound(bytArray)
        
        bSkip = False

        If lDataFactor = 2 And i Mod 2 = 0 Then bSkip = True
            
        If Not bSkip Then

            bytArray(i) = bytArray(i) Xor DirXor(((i - 1) Mod 4) + 1)
            
            If bytArray(i) <> 0 Then
                sFilePath = sFilePath & Chr(bytArray(i))
            Else
                Exit For
            End If
        
        End If
        
    Next i
    
    FilePath = sFilePath
    
End Sub

Private Sub GetFileOffset(iFile As Integer, iFilenumber As Long)
Dim lFileOffset As Long
Dim bytArray() As Byte
Dim i As Long
    ReDim bytArray(1 To 4)
        
    Get iFile, DirOffset + (CLng(iFilenumber) - 1) * ((128 + 256) * lDataFactor + 12) + ((128 + 256) * lDataFactor) + 1, bytArray
    Get iFile, DirOffset + (CLng(iFilenumber) - 1) * ((128 + 256) * lDataFactor + 12) + ((128 + 256) * lDataFactor) + 1, lFileOffset
    
    For i = LBound(bytArray) To UBound(bytArray)
        
        bytArray(i) = bytArray(i) Xor DirXor(((i - 1) Mod 4) + 1)
        
    Next i
    
    lFileOffset = lFileOffset Xor DirXorLong
    
    FileOffset = lFileOffset
    
End Sub

Private Sub GetFileSize(iFile As Integer, iFilenumber As Long)
Dim lFileSize As Long
Dim bytArray() As Byte
Dim i As Long
    ReDim bytArray(1 To 4)
        
    Get iFile, DirOffset + (CLng(iFilenumber) - 1) * ((128 + 256) * lDataFactor + 12) + ((128 + 256) * lDataFactor) + 5, bytArray
    Get iFile, DirOffset + (CLng(iFilenumber) - 1) * ((128 + 256) * lDataFactor + 12) + ((128 + 256) * lDataFactor) + 5, lFileSize
    
    For i = LBound(bytArray) To UBound(bytArray)
        
        bytArray(i) = bytArray(i) Xor DirXor(((i - 1) Mod 4) + 1)
        
    Next i
    
    lFileSize = lFileSize Xor DirXorLong
    
    FileSize = lFileSize

End Sub

Private Sub GetFileXor(iFile As Integer, iFilenumber As Long)
Dim lFileXor As Long
Dim bytArray() As Byte
Dim i As Long

    ReDim FileXor(1 To 4)
        
    Get iFile, DirOffset + (CLng(iFilenumber) - 1) * ((128 + 256) * lDataFactor + 12) + ((128 + 256) * lDataFactor) + 9, FileXor
    Get iFile, DirOffset + (CLng(iFilenumber) - 1) * ((128 + 256) * lDataFactor + 12) + ((128 + 256) * lDataFactor) + 9, lFileXor
    
    For i = LBound(FileXor) To UBound(FileXor)
        
        FileXor(i) = FileXor(i) Xor DirXor(((i - 1) Mod 4) + 1)
        
    Next i

End Sub

Private Sub Unpack(iFile As Integer, iFilenumber As Long)
Dim iFile2 As Integer
Dim bytArray() As Byte
Dim i As Long
Dim sDirectory
 
    sLogProgress = "File : " & iFilenumber & " " & FilePath & vbTab & " Extracting ... " & vbCrLf
    Call PrintLog
    
    Call CreateDirectory
    
    If FileSize > 0 Then
        
        ReDim bytArray(1 To FileSize)
            
        Get iFile, FileOffset + 1, bytArray
            
        For i = LBound(bytArray) To UBound(bytArray) - (UBound(bytArray) Mod 4)
             
           bytArray(i) = bytArray(i) Xor FileXor(((i - 1) Mod 4) + 1)
        
            If i Mod 100 = 0 Then DoEvents
                
        Next i
    
    End If
    
    iFile2 = FreeFile

    Open sExtractPath & "\" & FilePath For Binary As iFile2
    
    Put iFile2, 1, bytArray
    
    Close iFile2
    
    sLogData = "File : " & iFilenumber & " " & FilePath & vbTab & " Extracted !!" & vbCrLf & sLogData
    sLogProgress = ""
    
    Call PrintLog
    
End Sub

Private Sub CreateDirectory()
Dim sDirectory As String
Dim vFilePath
Dim i As Long
    
    sDirectory = sExtractPath
    
    On Error Resume Next
        
        vFilePath = Split(FilePath, "\")
            
        For i = LBound(vFilePath) To UBound(vFilePath) - 1
        
            sDirectory = sDirectory & "\" & vFilePath(i)
            MkDir sDirectory
            
        Next i
        
    On Error GoTo 0
    
End Sub

Private Sub PrintLog()
    txtOperationLog = sLogHeader & vbCrLf & sLogProgress & sLogData
    DoEvents
End Sub

Private Sub cmdFind_Click()
    cd.filter = "Pliki ARC (*.arc)|*.arc"
    cd.InitDir = txtFileName.Text
    cd.ShowOpen
    
    sExtractPath = Trim(Left(cd.FileName, Len(cd.FileName) - Len(cd.FileTitle)))
    txtFileName = cd.FileName
    
End Sub

Private Sub Form_Resize()

      If Not Me.WindowState = vbMinimized Then
        
        If Not Me.WindowState = vbMaximized Then
            
            If Me.Height < 5250 Then Me.Height = 5250
            If Me.Width < 7020 Then Me.Width = 7020
            
        End If
        
        Call txtOperationLog.Move(txtOperationLog.Left, txtOperationLog.Top, Me.Width - 300, Me.Height - txtOperationLog.Top - cmdExtract.Height - 800)
        cmdExtract.Top = txtOperationLog.Top + txtOperationLog.Height + 100
        cmdExtract.Left = Me.Width - cmdExtract.Width - 300
        
    End If
End Sub
